---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:11
---
local _, BohemkaDKP = ...

function BohemkaDKP:dump(o)
    if type(o) == 'table' then
        local s = '{ '
        for k,v in pairs(o) do
            if type(k) ~= 'number' then k = '"'..k..'"' end
            s = s .. '['..k..'] = ' .. BohemkaDKP:dump(v) .. ','
        end
        return s .. '} '
    else
        return tostring(o)
    end
end

function BohemkaDKP:debugMessage(...)
    str = ''
    if type(...) == 'table' then
        str = BohemkaDKP:dump(...)
    else
        for _,v in pairs({...}) do
            str = str .. tostring(v) .. ' '
        end
    end
    print(string.format(BohemkaDKP.STRING.DEBUG, BohemkaDKP.NAME, str))
end

function BohemkaDKP:Debug(...)
    if not BohemkaDKPConfig.debug then
        return
    end
    self:debugMessage(...)
end


function BohemkaDKP:Print(...)
    BohemkaDKP:debugMessage(...)
end

function BohemkaDKP:RepeatAfter(duration, cb)
    cb()
    C_Timer.After(duration, function () BohemkaDKP:RepeatAfter(duration, cb) end)
end

function BohemkaDKP:GetPlayerName(useFullName)
    if useFullName then
        local fullName, realm = UnitFullName("player")
        return fullName.."-"..(realm or GetRealmName())
    end
    return UnitName("player")
end


function BohemkaDKP:roundWhole(num, l)
    return math.floor(num / l + 0.5) * l
end

function BohemkaDKP:colorize(text, color)
    local escapeColor = format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
    return escapeColor..text.."|r"
end


function BohemkaDKP:IsPlayerLootMaster()
    local _, masterlooterPartyID, _ = GetLootMethod()
    return masterlooterPartyID == 0
end

function BohemkaDKP:isDigit(value)
    value = tonumber(value)
    if value then
        return true
    end
    return false
end

function BohemkaDKP:GetNumVisibleGuildMembers()
    local totalMembers, onlineMembers, _ = GetNumGuildMembers();
    local numGuildMembers = 0;
    local showOffline = GetGuildRosterShowOffline();
    if (showOffline) then
        numGuildMembers = totalMembers;
    else
        numGuildMembers = onlineMembers;
    end
    return numGuildMembers
end

table.toString = function(t)
    local tableStr = {}
    for k,v in pairs(t) do
        table.insert(tableStr, k.."="..v)
    end
    return table.concat(tableStr, ",")
end

table.fromString = function(str)
    local data = { strsplit(",", str) }
    local t = {}
    for _, item in ipairs(data) do
        local k, v = strsplit("=", item)
        t[k] = v
    end
    return t
end
